--
-- See the NOTICE file distributed with
-- this work for additional information regarding copyright ownership.
-- con terra GmbH licenses this file to You under the Apache License, Version 2.0
-- (the "License"); you may not use this file except in compliance with
-- the License. You may obtain a copy of the License at
--
--     http://www.apache.org/licenses/LICENSE-2.0
--
-- Unless required by applicable law or agreed to in writing, software
-- distributed under the License is distributed on an "AS IS" BASIS,
-- WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-- See the License for the specific language governing permissions and
-- limitations under the License.
--


-------------------------------------------------------------------
-- * Table for template managenment
-------------------------------------------------------------------
CREATE TABLE SAVED_TEMPLATES (
    USERID VARCHAR2(128),
    GROUPID VARCHAR2(128),
    PROTECTIONLEVEL VARCHAR2(10),
    TEMPLATENAME VARCHAR2(255) NOT NULL,
    ISOCLASS VARCHAR2(255) NOT NULL,
    TEMPLATE CLOB,
    CONSTRAINT SAVED_TEMPLATES_PC PRIMARY KEY (TEMPLATENAME, ISOCLASS)
);

-------------------------------------------------------------------
-- * Table for locking metadata ids
-------------------------------------------------------------------
CREATE TABLE LOCKING (
    ID NUMBER CONSTRAINT PK_ID_LOCKING PRIMARY KEY,
    RESOURCEIDENTIFIER VARCHAR2(255) NOT NULL UNIQUE,
    LIFETIME NUMBER(10) NOT NULL,
    CREATION NUMBER(10) NOT NULL,
    USERID VARCHAR(128),
    GROUPID VARCHAR(128)
);

-------------------------------------------------------------------
-- Trigger for locking
-------------------------------------------------------------------
CREATE SEQUENCE LOCKING_SEQ;

CREATE OR REPLACE TRIGGER LOCKING_TRG
BEFORE INSERT ON LOCKING
FOR EACH ROW
DECLARE seq_val NUMBER;
BEGIN
SELECT LOCKING_SEQ.nextval INTO seq_val FROM DUAL;
:new.id := seq_val;
END;
/
