--
-- See the NOTICE file distributed with
-- this work for additional information regarding copyright ownership.
-- con terra GmbH licenses this file to You under the Apache License, Version 2.0
-- (the "License"); you may not use this file except in compliance with
-- the License. You may obtain a copy of the License at
--
--     http://www.apache.org/licenses/LICENSE-2.0
--
-- Unless required by applicable law or agreed to in writing, software
-- distributed under the License is distributed on an "AS IS" BASIS,
-- WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-- See the License for the specific language governing permissions and
-- limitations under the License.
--

-------------------------------------------------------------------
-- * Table for template managenment
-------------------------------------------------------------------

CREATE TABLE SAVED_TEMPLATES (
    USERID VARCHAR(128),
    GROUPID VARCHAR(128),
    PROTECTIONLEVEL VARCHAR(10),
    TEMPLATENAME VARCHAR(255) NOT NULL,
    ISOCLASS VARCHAR(255) NOT NULL,
    TEMPLATE TEXT,
    CONSTRAINT SAVED_TEMPLATES_PC PRIMARY KEY (TEMPLATENAME, ISOCLASS)
    );

-------------------------------------------------------------------
-- * Table for locking
-------------------------------------------------------------------
CREATE SEQUENCE LOCKING_SEQ;
CREATE TABLE LOCKING (
    ID INTEGER DEFAULT nextval('locking_seq') CONSTRAINT PK_ID_LOCKING PRIMARY KEY,
    RESOURCEIDENTIFIER VARCHAR(255) NOT NULL UNIQUE,
    LIFETIME INTEGER NOT NULL,
    CREATION INTEGER NOT NULL,
    USERID VARCHAR(128),
    GROUPID VARCHAR(128)
);